% Ctedra de Control Moderno (Ing. Electricista)
% Fac. de Ingeniera - UNLP

% Curso 2003


% Prctica #5:
% Ejemplo de diseo de controlador de tiempo mnimo


% planta continua (motor de corriente continua)
Gs = 10*tf(0.14,[3 1]);


% planta discreta
Gz = c2d(Gs,0.2);


% diseo 1:
n = 1;         % la rta. transitoria se extingue en 1 muestra
polz = [1 -1]; % error de estado estacionario nulo

% controlador de tiempo mnimo
num = [1 zeros(1,n)] - polz;
Dz1 = tf(num,polz,0.2)/Gz;

% lazo cerrado
L1 = Dz1*Gz;
S1 = 1/(1+L1);
T1 = L1*S1;
Su1 = Dz1*S1;

figure
subplot(211);
step(T1,2);
title('Salida y(k)');

subplot(212);
step(Su1,2);
title('Accin de control u(k)');


% diseo 2:
n = 3;         % la rta. transitoria se extingue en 3 muestra
polz = conv([1 -1],[1 0.7 0.4]); % error de estado estacionario nulo

% controlador de tiempo mnimo
num = [1 zeros(1,n)] - polz;
Dz2 = tf(num,polz,0.2)/Gz;

% lazo cerrado
L2 = Dz2*Gz;
S2 = 1/(1+L2);
T2 = L2*S2;
Su2 = Dz2*S2;

figure
subplot(211);
step(T2,2);
title('Salida y(k)');

subplot(212);
step(Su2,2);
title('Accin de control u(k)');