% Ctedra de Control Moderno (Ing. Electricista)
% Fac. de Ingeniera - UNLP

% Curso 2003


% Prctica #5:
% Ejemplo de diseo de controlador discreto aproximando uno de
% tiempo continuo


% planta continua
Pc = zpk([],[-1;-0.02],5);

% controlador PID continuo
kp = 0.6;    % ganancia proporcional
ki = 0.012;  % ganancia integral
kd = 0.4;    % ganancia derivativa
Cc = kp + tf(ki,[1 0]) + tf([kd 0],[1/10 1]);

% aproximacin discreta
T = 0.1;     % tiempo de muestreo
k1 = kp + kd/T;
k2 = ki*T - 2*kd/T - kp;
k3 = kd/T;

Cd = tf([k1 k2 k3],[1 -1 0],T);


% transferemcia de lazo cerrado
Tc = feedback(Pc*Cc,1); % continuo
step(Tc);
hold on

Pd = c2d(Pc,T);   
Td = feedback(Pd*Cd,1); % discreto
step(Td);
